package forge

var primKeywords = []string{
	"parameter",
	"storage",
	"code",
	"False",
	"Elt",
	"Left",
	"None",
	"Pair",
	"Right",
	"Some",
	"True",
	"Unit",
	"PACK",
	"UNPACK",
	"BLAKE2B",
	"SHA256",
	"SHA512",
	"ABS",
	"ADD",
	"AMOUNT",
	"AND",
	"BALANCE",
	"CAR",
	"CDR",
	"CHECK_SIGNATURE",
	"COMPARE",
	"CONCAT",
	"CONS",
	"__CREATE_ACCOUNT__", // DEPRECATED
	"CREATE_CONTRACT",
	"IMPLICIT_ACCOUNT",
	"DIP",
	"DROP",
	"DUP",
	"EDIV",
	"EMPTY_MAP",
	"EMPTY_SET",
	"EQ",
	"EXEC",
	"FAILWITH",
	"GE",
	"GET",
	"GT",
	"HASH_KEY",
	"IF",
	"IF_CONS",
	"IF_LEFT",
	"IF_NONE",
	"INT",
	"LAMBDA",
	"LE",
	"LEFT",
	"LOOP",
	"LSL",
	"LSR",
	"LT",
	"MAP",
	"MEM",
	"MUL",
	"NEG",
	"NEQ",
	"NIL",
	"NONE",
	"NOT",
	"NOW",
	"OR",
	"PAIR",
	"PUSH",
	"RIGHT",
	"SIZE",
	"SOME",
	"SOURCE",
	"SENDER",
	"SELF",
	"STEPS_TO_QUOTA",
	"SUB",
	"SWAP",
	"TRANSFER_TOKENS",
	"SET_DELEGATE",
	"UNIT",
	"UPDATE",
	"XOR",
	"ITER",
	"LOOP_LEFT",
	"ADDRESS",
	"CONTRACT",
	"ISNAT",
	"CAST",
	"RENAME",
	"bool",
	"contract",
	"int",
	"key",
	"key_hash",
	"lambda",
	"list",
	"map",
	"big_map",
	"nat",
	"option",
	"or",
	"pair",
	"set",
	"signature",
	"string",
	"bytes",
	"mutez",
	"timestamp",
	"unit",
	"operation",
	"address",
	"SLICE",
	"DIG",
	"DUG",
	"EMPTY_BIG_MAP",
	"APPLY",
	"chain_id",
	"CHAIN_ID",
	"LEVEL",
	"SELF_ADDRESS",
	"never",
	"NEVER",
	"UNPAIR",
	"VOTING_POWER",
	"TOTAL_VOTING_POWER",
	"KECCAK",
	"SHA3",
	"PAIRING_CHECK",
	"bls12_381_g1",
	"bls12_381_g2",
	"bls12_381_fr",
	"sapling_state",
	"sapling_transaction",
	"SAPLING_EMPTY_STATE",
	"SAPLING_VERIFY_UPDATE",
	"ticket",
	"TICKET",
	"READ_TICKET",
	"SPLIT_TICKET",
	"JOIN_TICKETS",
	"GET_AND_UPDATE",
}

// first bytes
const (
	ByteInt            = 0x00
	ByteString         = 0x01
	ByteArray          = 0x02
	BytePrim           = 0x03
	BytePrimAnnots     = 0x04
	BytePrimArg        = 0x05
	BytePrimArgAnnots  = 0x06
	BytePrimArgs       = 0x07
	BytePrimArgsAnnots = 0x08
	ByteGeneralPrim    = 0x09
	ByteBytes          = 0x0a
)

// custom prim
const (
	PrimArray = "_array"
)

var (
	operationTags = map[string]string{
		"endorsement":                 "0",
		"proposals":                   "5",
		"ballot":                      "6",
		"seed_nonce_revelation":       "1",
		"double_endorsement_evidence": "2",
		"double_baking_evidence":      "3",
		"activate_account":            "4",
		"reveal":                      "107",
		"transaction":                 "108",
		"origination":                 "109",
		"delegation":                  "110",
		"register_global_constant":    "111",
	}

	entrypointTags = map[string]byte{
		"default":         0,
		"root":            1,
		"do":              2,
		"set_delegate":    3,
		"remove_delegate": 4,
	}
)
